// Copyright (c) 2023, NVIDIA CORPORATION & AFFILIATES. All rights reserved.
//
// NVIDIA CORPORATION and its licensors retain all intellectual property
// and proprietary rights in and to this software, related documentation
// and any modifications thereto.  Any use, reproduction, disclosure or
// distribution of this software and related documentation without an express
// license agreement from NVIDIA CORPORATION is strictly prohibited.

#ifndef CUBLASDX_VERSION_HPP
#define CUBLASDX_VERSION_HPP

/// \def CUBLASDX_VERSION
/// \brief CUBLASDX library version
///
///
/// @note
/// CUBLASDX_VERSION / 1000 - major version <br/>
/// CUBLASDX_VERSION / 100 % 100 - minor version <br/>
/// CUBLASDX_VERSION % 100 - patch level <br/>
#define CUBLASDX_VERSION 101

#ifndef DOXYGEN_SHOULD_SKIP_THIS

#define CUBLASDX_VERSION_MAJOR 0
#define CUBLASDX_VERSION_MINOR 1
#define CUBLASDX_VERSION_PATCH 1

#endif // DOXYGEN_SHOULD_SKIP_THIS

#endif // CUBLASDX_VERSION_HPP
