// Copyright (c) 2019, NVIDIA CORPORATION & AFFILIATES.  All rights reserved.
//
// NVIDIA CORPORATION and its licensors retain all intellectual property
// and proprietary rights in and to this software, related documentation
// and any modifications thereto.  Any use, reproduction, disclosure or
// distribution of this software and related documentation without an express
// license agreement from NVIDIA CORPORATION is strictly prohibited.

#ifndef CUFFTDX_VERSION_HPP
#define CUFFTDX_VERSION_HPP

/// \def CUFFTDX_VERSION
/// \brief cuFFTDx library version
///
///
/// @note
/// CUFFTDX_VERSION / 1000 - major version <br/>
/// CUFFTDX_VERSION / 100 % 100 - minor version <br/>
/// CUFFTDX_VERSION % 100 - patch level <br/>
#define CUFFTDX_VERSION 1200

#ifndef DOXYGEN_SHOULD_SKIP_THIS

#define CUFFTDX_VERSION_MAJOR 1
#define CUFFTDX_VERSION_MINOR 2
#define CUFFTDX_VERSION_PATCH 0

#endif // DOXYGEN_SHOULD_SKIP_THIS

#endif // CUFFTDX_VERSION_HPP
